// uno_client_ai		ver.0.00
//copyright 2012 Beer[Tsutsumi Hiroyuki]

#include	"unoai.h"

#define	VER		"ver.0.00"
#define	DATE	"2012. 2.12"

int	main(int argc,char **argv)
{
	unoaiapp	app(argc,argv);
	app.Run();
	return(0);
}
//------------------------------------------------
unoaiapp::unoaiapp(int argc,char **argv):BApplication("application/x-vnd.Beer-unoai")
{
	strcpy(myname,"unoai");
	strcpy(server,"127.0.0.1");	//local
	for(int i=1;i<argc;i++){
		if(argv[i][0]!='-')continue;
		if(strlen(argv[i])<2)continue;
		if(argv[i][1]=='n'){	//player name
			strncpy(myname,argv[i]+2,15);myname[15]=0;
		}
		if(argv[i][1]=='s'){	//server
			strncpy(server,argv[i]+2,15);server[63]=0;
		}
	}

#if	B_BEOS_VERSION>=0x0520
	app_info	ai;	be_app->GetAppInfo(&ai);
	BPath	ap(&ai.ref),dp;
	ap.GetParent(&dp);
	BPath	lp(dp);
	lp.Append("Language/Dictionaries");
	lp.Append("unoai");
	be_locale.LoadLanguageFile(lp.Path());
#endif

	quit=false;
	memset(rb,PACSIZE,0);	memset(sb,PACSIZE,0);
	myno=-1;
	pno=-1;		flg=0;

	w=new unoaiwindow(BRect(100,100,499,399));
	client();
}

void unoaiapp::AboutRequested()
{ 
	BAlert *alert;
	alert=new BAlert("",
		"uno_client_ai "VER"   "DATE"\n"
		"    copyright Hiroyuki Tsutsumi\n\n"
		" E-mail : gch07232@nifty.ne.jp\n"
		"   HP   : http://www.eonet.ne.jp/~hirotsu/"
	,"Thank you");
	alert->Go();
}

void unoaiapp::client()
{
	standby();
	if(*rb!=QUIT){
		gamestart();
		gamemain();
		gameend();
	}
	BMessenger(w).SendMessage(B_QUIT_REQUESTED);
}

void unoaiapp::standby()
{
	if(ep.InitCheck())printf("error : BNetEndpoint : InitCheck()\n");

	char	s[PACSIZE];
	*s=JOIN;
	strcpy(s+1,myname);
	if(ep.Connect(server,PORT))printf("error : BNetEndpoint : Connect()\n");
	ep.Send(s,PACSIZE);

	int	rl;
	if((rl=ep.Receive(rb,PACSIZE))<0)printf("error : BNetEndPoint : Receive()\n");
//	ep.SetTimeout(B_INFINITE_TIMEOUT);
	ep.SetTimeout(1000);
	if(ep.SetNonBlocking(true))printf("error : BNetEndpoint : SetNonBlocking\n");



	while(1){			//standby
		snooze(10000);
		if(quit)break;

		if(*rb==JOIN){
			cnt=rb[2];
			for(int i=0;i<cnt;i++)strcpy(name[i],rb+i*16+3);
			strcpy(myname,name[myno=rb[1]]);
			*rb=0;
		}
		if(*rb==MES){
			mprint(rb+1);
			*rb=0;
		}
		if(*rb==QUIT)break;
		if(*rb==CARD)break;

		if(*sb){ep.Send(sb,PACSIZE);*sb=0;}
		ep.Receive(rb,PACSIZE);
	}
}

void unoaiapp::gamestart()
{
	srand(time(0));
	hit=0;
	wt=100;
}

void unoaiapp::gamemain()
{
	while(1){
		snooze(10000);
		if(quit)break;

		if(*rb==CARD){
			char	*rp=rb+1;
			pno=*(rp++);	flg=*(rp++);	drc=*(rp++);
			for(int i=0;i<cnt;i++)rank[i]=*(rp++);
			ycardc=*(rp++);	scardc=*(rp++);
			for(int i=0;i<cnt;i++)pcardc[i]=*(rp++);
			scard=*(rp++);
			memcpy(mycard,rp,pcardc[myno]);
			BMessenger(w->v).SendMessage('draw');
			*rb=0;
		}

		if(*sb){ep.Send(sb,PACSIZE);*sb=0;}
		int	rl=ep.Receive(rb,PACSIZE);
		if(rl>0){
			if(*rb==MES){
				mprint(rb+1);
				*rb=0;
			}
			if(*rb==QUIT)break;
		}

		aiplay();
	}
}

void unoaiapp::gameend()
{
}

void unoaiapp::aiplay()
{
	char	s[PACSIZE];
	if((pno==myno)&&(!(flg&0x2))){
		if(wt){
			if(--wt)return;
			wt=100;
		}
		uchar	te[120];
		int		tec=0;
		if(scard<0x10){
			te[tec++]=0xf1;te[tec++]=0xf2;te[tec++]=0xf3;te[tec++]=0xf4;	//color
		}else{
			for(int i=0;i<pcardc[myno];i++){								//put
				uchar	mc=mycard[i];
				if(((drc==1)&&((mc<0x10)||((scard&0xf0)==(mc&0xf0))))||((scard&0xf)==(mc&0xf)))te[tec++]=mc;
			}
			if(tec==0)te[tec++]=0x00;										//get
		}
		*s=PUT;
		s[1]=te[rand()%tec];
		ep.Send(s,PACSIZE);
	}
}

void unoaiapp::mprint(char *s)
{
	BMessage	msg('prnt');
	msg.AddString("str",s);
	BMessenger(w->v).SendMessage(&msg);
}
//------------------------------------------------
unoaiwindow::unoaiwindow(BRect frame):BWindow(frame,"unoai "VER,B_DOCUMENT_WINDOW,0)
{
	v=new unoaiview(BRect(0,0,399,299));
	AddChild(v);
	Show();
}

bool unoaiwindow::QuitRequested()
{
	((unoaiapp*)be_app)->quit=true;
	RemoveChild(v);

	BMessenger(be_app).SendMessage(B_QUIT_REQUESTED);
	return(true);
}

void unoaiwindow::setupmenus()
{
	BMenu		*m;
	BMenuItem	*mi;
	mb=new BMenuBar(BRect(0,0,20,20),"menubar");
	m=new BMenu(_T("File"));
	 mi=new BMenuItem(_T("About"),new BMessage(B_ABOUT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Quit"),new BMessage(B_QUIT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	mb->AddItem(m);
	AddChild(mb);
}
//------------------------------------------------
unoaiview::unoaiview(BRect frame):BView(frame,"unoaiview",B_FOLLOW_ALL,B_WILL_DRAW|B_PULSE_NEEDED)
{
	fr=frame;
	tv=NULL;
	bm=new BBitmap(frame,B_RGB_32_BIT,true);
	wv=new BView(frame,"workview",B_NOT_RESIZABLE,B_WILL_DRAW);
}

unoaiview::~unoaiview()
{
	if(tv)delete tv;
	if(wv)delete wv;
	if(bm)delete bm;
}

void unoaiview::AttachedToWindow()
{
	SetHighColor(255,255,255);
	SetViewColor(0x00,0xcc,0x00);
	SetLowColor(100,100,100);
	SetFont(be_bold_font);

	BRect	r(bm->Bounds());
	int	w=r.IntegerWidth(),h=r.IntegerHeight();

	rgb_color	fc={255,255,255};
	BFont	ff=be_plain_font;
	ff.SetSize(15);
	tv=new BTextView(BRect(w-200,0,w,h*.7-21),"uno_stt",BRect(10,10,189,h*.7-31),&ff,&fc,B_FOLLOW_NONE,B_WILL_DRAW);
	tv->MakeEditable(false);
	tv->MakeSelectable(false);
	AddChild(tv);
	tv->SetViewColor(0x22,0x22,0x44);
	redraw();
}

void unoaiview::Pulse()
{
	BPoint	p;	uint32	b;	GetMouse(&p,&b);
	if(b)return;
	if(fr!=Bounds()){
		fr=Bounds();
		if(bm)delete bm;
		bm=new BBitmap(fr,B_RGB_32_BIT,true);
		wv->ResizeTo(fr.Width(),fr.Height());
		redraw();
		Invalidate();

		int	w=fr.IntegerWidth(),h=fr.IntegerHeight();
		tv->MoveTo(w/2,0);
		tv->ResizeTo(w/2,h*.7-21);
		tv->ScrollToOffset(0);
		tv->ScrollToOffset(tv->TextLength());
		tv->SetTextRect(BRect(10,10,w/2-11,h*.7-31));
	}
}

void unoaiview::Draw(BRect rect)
{
	if(bm){
		DrawBitmap(bm,rect,rect);
	}
}

void unoaiview::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case 'draw':{
			redraw();
			Invalidate();
		}break;
		case 'prnt':{
			const char	*s;
			msg->FindString("str",&s);
			tv->Insert(s);
			tv->ScrollToOffset(tv->TextLength());
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void unoaiview::redraw()
{
	BRect	r(bm->Bounds());
	int	w=r.IntegerWidth(),h=r.IntegerHeight();

	unoaiapp	*g=(unoaiapp*)be_app;
	char	s[PACSIZE];
	BFont	ff=be_plain_font;
	wv->SetLowColor(0x00,0xcc,0x00);
	bm->Lock();
	bm->AddChild(wv);

	wv->FillRect(r,B_SOLID_LOW);

if(g->myno>=0){
	//colorcircle
	if(g->scard<0x10){
		wv->SetHighColor(0xaa,0x00,0x00);
		wv->FillEllipse(colr[0]=BRect(w*.05,h*.40-w*.04,w*.13,h*.40+w*.04));
		wv->SetHighColor(0x00,0x00,0xaa);
		wv->FillEllipse(colr[1]=BRect(w*.17,h*.40-w*.04,w*.25,h*.40+w*.04));
		wv->SetHighColor(0xaa,0xaa,0x00);
		wv->FillEllipse(colr[2]=BRect(w*.05,h*.55-w*.04,w*.13,h*.55+w*.04));
		wv->SetHighColor(0x00,0xaa,0x00);
		wv->FillEllipse(colr[3]=BRect(w*.17,h*.55-w*.04,w*.25,h*.55+w*.04));
	}

	//yama
	if(g->ycardc)drawcard(yamar=BRect(w*.05,h*.10,w*.13,h*.24),0xff);

	//sute
	if(g->scardc)drawcard(BRect(w*.17,h*.10,w*.25,h*.24),g->scard);

	//mycard
	for(int i=0;i<g->pcardc[g->myno];i++){
		double	x=w*(i*2+1)/(g->pcardc[g->myno]*2)-w*.04;
		drawcard(mycardr[i]=BRect(x,h*.80,x+w*.08,h*.94),g->mycard[i]);
	}

	if(g->drc>1){	//draw
		ff.SetSize(h/15);
		wv->SetFont(&ff);
		wv->SetHighColor(0xee,0x88,0x77);
		wv->SetLowColor(0xaa,0x66,0x55);
		sprintf(s,"%d",g->drc);
		wv->DrawString(s,BPoint(w*.07,h*.19));
	}

	//left
	ff.SetSize(h/20);
	wv->SetFont(&ff);
	wv->SetHighColor(0x00,0x00,0x00);
	wv->SetLowColor(0x00,0x88,0x00);
	if(g->ycardc){
		sprintf(s,"%d",g->ycardc);
		wv->DrawString(s,BPoint(w*.06,h*.30));
	}
	if(g->scardc){
		sprintf(s,"%d",g->scardc);
		wv->DrawString(s,BPoint(w*.18,h*.30));
	}

	//players
	const char	rm[4][4]={"1st","2nd","3rd","4th"};
	for(int i=0;i<g->cnt;i++){
		if(i==g->myno)wv->SetHighColor(0xcc,0x44,0x22);else wv->SetHighColor(0x00,0x00,0x00);
		wv->DrawString(g->name[i],BPoint(w*.32,h*(.10+i*.10)));
		if(g->rank[i])sprintf(s,"%s",rm[g->rank[i]-1]);else sprintf(s,"%3d",g->pcardc[i]);
		wv->DrawString(s,BPoint(w*.35,h*(.15+i*.10)));
	}

	//now
	if(g->pno>=0){
		if(g->flg&0x2){	//skip
			wv->SetHighColor(0x44,0x55,0x22);
		}else{
			wv->SetHighColor(0xdd,0xee,0x77);
		}
		float	x=w*.30,y=h*(.10+g->pno*.10),r=h*.02;
		if(g->flg&0x1){	//rev
			wv->FillTriangle(BPoint(x,y-r),BPoint(x-r,y+r),BPoint(x+r,y+r));
		}else{
			wv->FillTriangle(BPoint(x,y+r),BPoint(x-r,y-r),BPoint(x+r,y-r));
		}
	}
}

	wv->Sync();
	bm->RemoveChild(wv);
	bm->Unlock();
}

void unoaiview::drawcard(BRect rec,uchar no)
{
	int	w=rec.IntegerWidth(),h=rec.IntegerHeight();

	BFont	ff=be_plain_font;
	font_height	fh;
	char	s[16];

	//background
	if(no==0xff){
		wv->SetHighColor(0x44,0x44,0x44);
	}else{
		wv->SetHighColor(0xdf,0xd7,0xd0);
	}
	wv->FillRoundRect(rec,2,2);
	if(no==0xff)return;

	//center
	float	ww,hh;
	if(no>=0x40){		//green
		wv->SetHighColor(0x00,0xbb,0x00);
		wv->SetLowColor(0x88,0xdd,0x88);
	}else if(no>=0x30){	//yellow
		wv->SetHighColor(0xbb,0xbb,0x00);
		wv->SetLowColor(0xdd,0xdd,0x88);
	}else if(no>=0x20){	//blue
		wv->SetHighColor(0x00,0x00,0xdd);
		wv->SetLowColor(0x88,0x88,0xee);
	}else if(no>=0x10){	//red
		wv->SetHighColor(0xdd,0x00,0x00);
		wv->SetLowColor(0xee,0x88,0x88);
	}
	if((no&0xf)>0xc){
		if(no>=0x10)wv->FillEllipse(BPoint(rec.left+w/2,rec.top+h/2),w/3,w/3);
		wv->SetHighColor(0x00,0x00,0x00);
		wv->SetLowColor(0x88,0x88,0x88);
		ff.SetSize(w/2.5);
		ff.GetHeight(&fh);
		hh=fh.ascent+fh.descent;
		wv->SetFont(&ff);
		if((no&0xf)==0xd){		//wild
			sprintf(s,"Wild");
			ww=ff.StringWidth(s);
			wv->DrawString(s,BPoint(rec.left+w/2-ww/2,rec.top+h/2+hh/2-fh.descent));
		}else{					//wilddraw
			sprintf(s,"Wild");
			ww=ff.StringWidth(s);
			wv->DrawString(s,BPoint(rec.left+w/2-ww/2,rec.top+h/2-fh.descent));
			sprintf(s,"Draw");
			ww=ff.StringWidth(s);
			wv->DrawString(s,BPoint(rec.left+w/2-ww/2,rec.top+h/2+fh.ascent));
		}
	}else{
		if((no&0xf)<0xa){			//0-9
			sprintf(s,"%x",no&0xf);
			ff.SetSize(w/1.2);
		}else if((no&0xf)==0xa){	//reverse
			sprintf(s,"Rev");
			ff.SetSize(w/2.5);
		}else if((no&0xf)==0xb){	//skip
			sprintf(s,"Skip");
			ff.SetSize(w/2.5);
		}else if((no&0xf)==0xc){	//draw
			sprintf(s,"Draw");
			ff.SetSize(w/2.5);
		}
		ff.GetHeight(&fh);
		hh=fh.ascent+fh.descent;
		wv->SetFont(&ff);
		ww=ff.StringWidth(s);
		wv->DrawString(s,BPoint(rec.left+w/2-ww/2,rec.top+h/2+hh/2-fh.descent));
	}
}
