// uno_server		ver.0.00
//copyright 2012 Beer[Tsutsumi Hiroyuki]

#include	"unos.h"

#define	VER		"ver.0.00"
#define	DATE	"2012. 2.12"

int	main()
{
	unoapp	app;
	app.Run();
	return(0);
}
//------------------------------------------------
unoapp::unoapp():BApplication("application/x-vnd.Beer-uno")
{
	quit=false;

#if	B_BEOS_VERSION>=0x0520
	app_info	ai;	be_app->GetAppInfo(&ai);
	BPath	ap(&ai.ref),dp;
	ap.GetParent(&dp);
	BPath	lp(dp);
	lp.Append("Language/Dictionaries");
	lp.Append("uno");
	be_locale.LoadLanguageFile(lp.Path());
#endif

	memset(rb,PACSIZE,0);
	w=new unowindow(BRect(50,50,449,349));
	server();
}

bool unoapp::QuitRequested()
{
	char	s[PACSIZE];
	*s=QUIT;
	send(-1,s);
	return(true);
}

void unoapp::AboutRequested()
{ 
	BAlert *alert;
	alert=new BAlert("",
		"uno_server "VER"   "DATE"\n"
		"    copyright Hiroyuki Tsutsumi\n\n"
		" E-mail : gch07232@nifty.ne.jp\n"
		"   HP   : http://www.eonet.ne.jp/~hirotsu/"
	,"Thank you");
	alert->Go();
}

void unoapp::server()
{
	standby();
	gamestart();
	gamemain();
	gameend();
	BMessenger(w).SendMessage(B_QUIT_REQUESTED);
}

void unoapp::standby()
{
	char	s[PACSIZE];
	cnt=0;

	if(ep.InitCheck())printf("error : BNetEndpoint : InitCheck()\n");
	if(ep.Bind(PORT))printf("error : BNetEndpoint : Bind()\n");
	if(ep.Listen())printf("error : BNetEndpoint : Listen()\n");
	mprint("Waiting for 4 players\n");

	while(cnt<4){
		snooze(10000);
		if(quit)break;
		if((cep[cnt]=ep.Accept(100))!=NULL){
			int	rl;
			if((rl=cep[cnt]->Receive(rb,PACSIZE))<0)printf("error : BNetEndPoint : Receive()\n");
			if(*rb==JOIN){
				if(rb[1]){
					strncpy(name[cnt],rb+1,15);	name[cnt][15]=0;
				}else{
					sprintf(name[cnt],"player%d",cnt+1);
				}
//				cep[cnt]->SetTimeout(B_INFINITE_TIMEOUT);
				cep[cnt]->SetTimeout(1000);
				if(cep[cnt]->SetNonBlocking(true))printf("error : BNetEndpoint : SetNonBlocking\n");
				sprintf(s,"@you are player %d\n",cnt+1);
				send(cnt,s);
				sprintf(s,"@join : player %d : [%s]\n",cnt+1,name[cnt]);
				mprint(s+1);
				send(-1,s);
				cnt++;
				*s=JOIN;
				s[2]=cnt;
				for(int i=0;i<cnt;i++)memcpy(s+i*16+3,name[i],16);
				s[cnt*16+3]=0;
				for(int i=0;i<cnt;i++){
					s[1]=i;
					send(i,s);
				}
			}else{
				cep[cnt]->Close();
			}
		}

		for(int i=0;i<cnt;i++){
			int	rl;
			rl=cep[i]->Receive(rb,PACSIZE);
			if(rl>0){
				if(*rb==MES){
					sprintf(s,"%x:%s : %s",i+1,name[i],rb+1);
					mprint(s);
					sprintf(s,"@[%s] %s",name[i],rb+1);
					send(-1,s);
				}
			}
		}
	}
}

void unoapp::gamestart()
{
	char	s[PACSIZE];
	sprintf(s,"@Game start\n");
	mprint(s+1);
	send(-1,s);

	//gameinit
	srand(time(0));
	ycardc=108;scardc=0;
	for(int i=0;i<4;i++){pcardc[i]=0;rank[i]=0;}
	memcpy(ycard,card,108);
	shuffle();
	for(int i=0;i<4;i++){
		cget(i,7);	//yama>player
	}
	while(ycard[ycardc-1]<0x10)shuffle();

	fin=0;pno=0;flg=0;drc=1;
	scard[scardc++]=ycard[--ycardc];	//first card
}

void unoapp::gamemain()
{
	int	job=0;
	while(1){
		snooze(10000);
		if(quit)break;

		if(job==0){
			if(fin==cnt-1)pno=-1;		//gameover
			sendcards();
			if(pno<0)break;
			job=1;
		}
		if(job==1){	//inputwait,skipwait
			if(flg&0x2){
				if(wt==0){
					flg&=0xd;
					job=3;
				}else wt--;
			}
		}
		if(job==2){	//shori
			uchar	sc=scard[scardc-1];
			char	pc=rb[1];
			if((pc>0)&&(exist(pno,pc)>=0)){						//card
				if(((drc==1)&&((pc<0x10)||((sc&0xf0)==(pc&0xf0))))||((sc&0xf)==(pc&0xf))){
					cput(pno,exist(pno,pc));
					if((pc&0xf)==0xa)flg^=0x1;						//reverse
					if((pc&0xf)==0xb){flg|=0x2;wt=100;}				//skip
					if((pc&0xf)==0xc){flg|=0x4;drc=drc>1?drc+2:2;}	//draw
					if(pc==0xe){flg|=0x8;drc=drc>1?drc+4:4;}		//wilddraw
					job=(pc<0x10)?0:3;
				}
			}else if((pc==0)&&(sc>=0x10)){						//yama(00)
				cget(pno,drc);
				flg&=0x3;drc=1;
				job=0;
			}else{												//color(f1-f4)
				if(sc<0x10){
					scard[scardc-1]=sc|((pc&0xf)<<4);
					job=3;
				}
			}
		}
		if(job==3){	//nextplayer
			while(pcardc[pno=(flg&0x1)?(pno+cnt-1)%cnt:(pno+1)%cnt]==0);
			job=0;
		}

		for(int i=0;i<cnt;i++){	//input
			int	rl;
			rl=cep[i]->Receive(rb,PACSIZE);
			if(rl>0){
				if(*rb==MES){
					char	s[PACSIZE];
					sprintf(s,"%x:%s : %s",i+1,name[i],rb+1);
					mprint(s);
					sprintf(s,"@[%s] %s",name[i],rb+1);
					send(-1,s);
				}
				if(*rb==PUT){
					if((job==1)&&(!(flg&0x2))&&(i==pno))job=2;
				}
			}
		}
	}
}

void unoapp::gameend()
{
	char	s[PACSIZE];
	sprintf(s,"@Game over\n");
	mprint(s+1);
	send(-1,s);

	while(1){
		snooze(10000);
		if(quit)break;
		for(int i=0;i<cnt;i++){
			int	rl;
			rl=cep[i]->Receive(rb,PACSIZE);
			if(rl>0){
				if(*rb==MES){
					char	s[PACSIZE];
					sprintf(s,"%x:%s : %s",i+1,name[i],rb+1);
					mprint(s);
					sprintf(s,"@[%s] %s",name[i],rb+1);
					send(-1,s);
				}
			}
		}
	}
}

void unoapp::sendcards()
{
	char	s[PACSIZE],*sp=s;
	*(sp++)=CARD;
	*(sp++)=pno;	*(sp++)=flg;	*(sp++)=drc;
	for(int i=0;i<cnt;i++)*(sp++)=rank[i];
	*(sp++)=ycardc;	*(sp++)=scardc;
	for(int i=0;i<cnt;i++)*(sp++)=pcardc[i];
	*(sp++)=scard[scardc-1];
	for(int i=0;i<cnt;i++){
		memcpy(sp,pcard[i],pcardc[i]);	sp[pcardc[i]]=0;
		send(i,s);
	}
}

void unoapp::send(int who,char *s)
{
	if(who<0){
		for(int i=0;i<cnt;i++){
			if(cep[i]->Send(s,PACSIZE)<=0)printf("error : BNetEndpoint : Send\n");
		}
	}else{
		if(cep[who]->Send(s,PACSIZE)<=0)printf("error : BNetEndpoint : Send\n");
	}
}

void unoapp::shuffle()
{	//yamacard shuffle
	for(int i=0;i<100;i++){
		int j=rand()%ycardc,k=rand()%ycardc;
		uchar	c=ycard[j];ycard[j]=ycard[k];ycard[k]=c;
	}
}

void unoapp::cget(int to,int count)
{
	for(int i=0;i<count;i++){
		if(ycardc==0){		//sute > yama > shuffle
			for(int j=0;j<scardc-1;j++){
				ycard[j]=scard[j];
				if((ycard[j]&0xf)>0xc)ycard[j]&=0xf;
			}
			scard[0]=scard[scardc-1];
			ycardc=scardc-1;
			scardc=1;
			shuffle();
		}
		pcard[to][pcardc[to]++]=ycard[--ycardc];
	}
}

void unoapp::cput(int from,int no)
{
	scard[scardc++]=pcard[from][no];
	if(--pcardc[from]==0)rank[from]=++fin;
	for(int i=no;i<pcardc[from];i++)pcard[from][i]=pcard[from][i+1];
}

int	unoapp::exist(char who,uchar cd)
{
	int	no=-1;
	for(int i=0;i<pcardc[who];i++)if(pcard[who][i]==cd)no=i;
	return(no);
}

void unoapp::mprint(char *s)
{
	BMessage	msg('prnt');
	msg.AddString("str",s);
	BMessenger(w->v).SendMessage(&msg);
}
//------------------------------------------------
unowindow::unowindow(BRect frame):BWindow(frame,"unowindow "VER,B_DOCUMENT_WINDOW,0)
{
	v=new unoview(BRect(0,0,399,299));
	AddChild(v);
	Show();
}

bool unowindow::QuitRequested()
{
	((unoapp*)be_app)->quit=true;
	RemoveChild(v);

	BMessenger(be_app).SendMessage(B_QUIT_REQUESTED);
	return(true);
}

void unowindow::setupmenus()
{
	BMenu		*m;
	BMenuItem	*mi;
	mb=new BMenuBar(BRect(0,0,20,20),"menubar");
	m=new BMenu(_T("File"));
	 mi=new BMenuItem(_T("About"),new BMessage(B_ABOUT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Quit"),new BMessage(B_QUIT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	mb->AddItem(m);
	AddChild(mb);
}
//------------------------------------------------
unoview::unoview(BRect frame):BView(frame,"unoview",B_FOLLOW_NONE,B_WILL_DRAW)
{
	tv=NULL;
}

unoview::~unoview()
{
	if(tv)delete tv;
}

void unoview::AttachedToWindow()
{
	SetHighColor(255,255,255);
	SetViewColor(0,0,0);
	SetLowColor(100,100,100);
	SetFont(be_bold_font);

	rgb_color	fc={255,255,255};
	BFont	ff=be_plain_font;
	ff.SetSize(15);
	tv=new BTextView(BRect(0,0,399,299),"uno_stt",BRect(10,10,389,289),&ff,&fc,B_FOLLOW_NONE,B_WILL_DRAW);
	tv->SetViewColor(0,0,0);
	tv->MakeEditable(false);
	tv->MakeSelectable(false);
	AddChild(tv);
	tv->Show();
}

void unoview::Draw(BRect rect)
{
}

void unoview::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case 'prnt':{
			const char	*s;
			msg->FindString("str",&s);
			tv->Insert(s);
			tv->ScrollToOffset(tv->TextLength());
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}
